import { Http, RequestOptionsArgs, Response } from '@angular/http';
import { Observable } from 'rxjs/Observable';
import 'rxjs/add/observable/of';
import 'rxjs/add/operator/map';
export interface CacheOptions {
    permanent: boolean;
}
export interface CachedHttpResponse {
    headers: {
        [name: string]: any;
    } | null;
    status: number;
    statusText: string | null;
    text: string;
    url: string;
}
export declare type BackingStore = {
    [key: string]: CachedHttpResponse;
};
export declare class HttpWithStateTransfer {
    private backingStore;
    private http;
    constructor(http: Http, backingStore: BackingStore);
    stateForTransfer(): any;
    get(url: string, options?: CacheOptions, requestOptions?: RequestOptionsArgs): Observable<Response>;
    private getCachedResponse(cacheKey, provider, options?);
}
export declare function defaultBackingStoreFactory(): any;
export declare class HttpWithStateTransferModule {
}
